\documentclass[11pt, oneside]{article}   	
% use "amsart" instead of "article" for AMSLaTeX format
%\usepackage[parfill]{parskip}    		% Activate to begin paragraphs with an empty line rather than an indent
	
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{graphicx}
\usepackage{xcolor}
\usepackage{soul}
\usepackage{hyperref}
\usepackage{algorithm}
\usepackage[noend]{algpseudocode}
\usepackage{dsfont}
\usepackage{caption}
\usepackage{subcaption}
\usepackage{placeins}
\usepackage{mathtools}
\usepackage{tikz}
%\usepackage{algcompatible}

\DeclarePairedDelimiter\floor{\lfloor}{\rfloor}

%SetFonts

%SetFonts


\title{D-Cliques Construction}
\author{Paulette Vázquez, Alexandra Senderovich (equal contributions)}
%\date{}							% Activate to display a given date or no date

\begin{document}
\maketitle

\section{Introduction}
\label{section:introduction}
Recently, D-Cliques~\cite{bellet2021dcliques}, a new topology for Decentralized Federated Learning~\cite{kairouz2019advances} that removes the effect of \textit{local class bias} (aka \textit{label distribution skew}) was proposed. In the D-Cliques paper, all the experiments were conducted under the following assumptions:
\begin{enumerate}
    \item All classes have the same number of examples.
    \item All classes are represented on the same number of nodes.
    \item All nodes have examples of only one class.
\end{enumerate}
However, these assumptions are unrealistic, thus the optimal algorithm that was suggested in the article should be superseded by an algorithm that works in a more general case.

The goal of this project is to explore the design space of topology construction algorithms that can be used to create such D-Cliques that their average skew is minimal.

The rest of the document is organized as follows: Section~\ref{section:problem-statement} formalizes the problem, Section~\ref{section:data-partition} explains data partition we used in our experiments, Section~\ref{section:baseline-algorithms} describes optimal solution and random algorithm, that serves us as lower and upper bounds respectively, Section~\ref{section:centralized-algorithm} describes centralized greedy algorithm of constructing D-Cliques, Section~\ref{section:decentralized-algorithms} organizes different ideas for decentralized solutions, Section~\ref{section:comparative-evaluation} compares convergence speed and performance in terms of average skew of different algorithms, Section~\ref{section:conclusion} sums up the obtained results and Section~\ref{section:future-work} mentions possible improvements and future steps.

\section[Problem Statement]{Problem Statement\footnote{This section was copied from \url{https://gitlab.epfl.ch/sacs/distributed-ml/d-cliques-construction/-/blob/master/main.pdf}}}
\label{section:problem-statement}
The problem of constructing a communication topology is a sub-problem of Decentralized Federated Learning (DFL)~\cite{kairouz2019advances}. We first introduce the DFL problem to provide context in Section~\ref{section:problem:dfl}, we introduce one algorithm, D-SGD~\cite{lian2017d-psgd}, which we use to solve DFL in Section~\ref{section:problem:d-sgd}, and we present how to construct D-Cliques for D-SGD in Section~\ref{section:problem:construction-d-cliques}.

\subsection{Decentralized Federated Learning}
\label{section:problem:dfl}

We consider a set $N = \{1, \dots, n \}$ of $n$ nodes seeking to
collaboratively solve a classification task with $L$ classes. Each node has access to a local dataset that
 follows its own local distribution $D_i$. The goal is to find a global model
 $x$ that performs well on the union of the local distributions by minimizing
 the average training loss:
\begin{equation}
\min_{x} \frac{1}{n}\sum_{i=1}^{n} \mathds{E}_
{s_i \sim D_i} [F_i(x;s_i)],
\label{eq:dist-optimization-problem}
\end{equation}
where $s_i$ is a data example drawn from $D_i$ and $F_i$ is the loss function
on node $i$. Therefore, $\mathds{E}_{s_i \sim D_i} F_i(x;s_i)$ denotes  the
expected loss of model $x$ on a random example $s_i$ drawn from $D_i$.

To collaboratively solve Problem \eqref{eq:dist-optimization-problem}, each
node can exchange messages with its neighbors in an undirected network graph
$G(N,E)$ where $\{i,j\}\in E$ denotes an edge (communication channel)
between nodes $i$ and $j$.

\subsection{D-SGD Training Algorithm}
\label{section:problem:d-sgd}

To solve Problem~\ref{eq:dist-optimization-problem}, we use the popular Decentralized Stochastic
Gradient Descent algorithm, aka D-SGD~\cite{lian2017d-psgd}. As
shown in Algorithm~\ref{Algorithm:D-PSGD},
a single iteration of D-SGD at node $i$ consists of sampling a mini-batch
from its local distribution
$D_i$, updating its local model $x_i$ by taking a stochastic gradient descent 
(SGD) step according to the mini-batch, and performing a weighted average of
its local model with those of its
neighbors.
This weighted average is defined by a
mixing matrix $W$, in which $W_{ij}$ corresponds to the weight of
the outgoing connection from node $i$ to $j$ and $W_{ij} = 0$ for $
\{i,j\}\notin
E$. To ensure that the local models converge on average to a stationary
point
of Problem
\eqref{eq:dist-optimization-problem}, $W$
must be doubly
stochastic ($\sum_{j \in N} W_{ij} = 1$ and $\sum_{j \in N} W_{ji} = 1$) and
symmetric, i.e. $W_{ij} = W_{ji}$~\cite{lian2017d-psgd}.

\begin{algorithm}[t]
   \caption{D-SGD~\cite{lian2017d-psgd}, Node $i$}
   \label{Algorithm:D-PSGD}
   \begin{algorithmic}[1]
        \State \textbf{Require:} initial model parameters $x_i^{(0)}$,
        learning rate $\gamma$, mixing weights $W$, mini-batch size $m$,
        number of steps $K$
        \For{$k = 1,\ldots, K$}
          \State $s_i^{(k)} \gets \text{mini-batch sample of size $m$ drawn
          from~} D_i$
          \State $x_i^{(k-\frac{1}{2})} \gets x_i^{(k-1)} - \gamma \nabla F(x_i^{(k-1)}; s_i^{(k)})$ 
          \State $x_i^{(k)} \gets \sum_{j \in N} W_{ji}^{(k)} x_j^{(k-\frac{1}{2})}$
        \EndFor
   \end{algorithmic}
\end{algorithm}

\subsection{Constructing D-Cliques}
\label{section:problem:construction-d-cliques}

To simplify the presentation, first consider the following definitions:
\begin{itemize}
  \item a \textit{global distribution} $D$ is the union of the local distributions of all participating nodes in $N$, i.e. $D = \bigcup\limits_{\substack{i \in N}} D_i$;
  \item a \textit{clique} $C$ is a subset of $N$ in which all nodes are connected to each other, i.e. $C \subseteq N~|~\forall_{i,j \in C} W_{ij} > 0$;
  \item a \textit{clique distribution} $D_C$ is the union of the local distributions of all nodes within a clique, i.e. $D_C = \bigcup\limits_{\substack{i \in C}} D_i$;
  \item a set of \textit{distributed cliques} $DC$ is a set of all cliques such that nodes in different cliques are disjoint, i.e. $DC = \{ C_1, C_2, \dots | \forall_{C_i, C_j, i \neq j} C_i \cap C_j = \emptyset \}$;
  \item the \textit{skew}, eq. \textit{local class bias}, between distributions $D_a$ and $D_b$ is the sum of the differences in the probabilities that a sample $(x,y)$ belongs to the same class in $L$ in both distributions, i.e.  $skew(D_a, D_b) = \sum\limits_{\substack{l \in L}} | p(y = l~|~(x,y) \in D_a) - p(y = l~|~(x,y) \in D_b) |$
  \footnote{To the best of our knowledge, this metric was first used to analyze and improve Federated Learning in Non-IID settings by Zhao et al.~\cite{zhao2018federated}.}
  \footnote{Some authors~\cite{zhao2018federated,tornado} call this definition the \textit{earth mover's distance (EMD)} between two distributions. However, this definition does not consider the difference in probabilities \textit{between different classes}, which removes the specificity of the EMD compared to bin-to-bin comparisons, as highlighted in the taxonomy of metrics of Rubner et al~\cite{rubner2000earth}. To minimize confusion, we will reserve EMD for metrics that do compare probabilities across classes.}.        
\end{itemize} 

The construction of D-Cliques consists in assigning weights in $W$, under the constraints presented in Section~\ref{section:problem:d-sgd}, such that the resulting corresponding graph exhibits the following properties: (1) the majority of edges in $E$ are found in \textit{cliques}; (2) the overall topology is sparse, i.e. $|E| \lll |N|^2$; (2) the skew of all clique distributions compared to $D$ is minimized, i.e. $\textit{min}_{DC} \sum_{C \in DC} skew(D_C, D)$.

In practical implementations, we do the construction of D-Cliques in four steps: (1) we select the number of cliques and their node membership;  (2) we assign edges between all pairs of nodes for each clique; (3) we assign inter-clique edges; (4) we select edge weights. We illustrate the approach in Algorithm~\ref{Algorithm:Abstract-Construction}.

   \begin{algorithm}[h]
   \caption{Abstract Construction of D-Cliques}
   \label{Algorithm:Abstract-Construction}
   \begin{algorithmic}[1]
        \State \textbf{Require:}
        \State~~ set of all nodes $N = \{ 1, 2, \dots, n \}$,
        \State~~ fn $\textit{cliquefy}(N)$ that assigns nodes in N to disjoint cliques,
        \State~~ fn $\textit{intraconnect}(DC)$ that returns edges intraconnecting cliques of $DC$,
        \State~~ fn $\textit{interconnect}(DC)$ that returns edges interconnecting cliques of $DC$,
        \State~~ fn $\textit{weights}(E)$ that assigns weights to edges in $E$ 
     
        \State $DC \leftarrow \textit{cliquefy}(N)$
        \State \Return $(weights(\textit{intraconnect}(DC) \cup \textit{interconnect}(DC)), DC)$
   \end{algorithmic}
\end{algorithm}

This project focuses on the exploration of the design space for (1), i.e. "\textit{cliquefy}" in Alg.~\ref{Algorithm:Abstract-Construction}. An exploration of sparse topologies for inter-clique connections, and the use of Metropolis-Hasting for assigning weights is discussed in the original D-Cliques paper~\cite{bellet2021dcliques}.

\section{Data Partition}
\label{section:data-partition}
We partitioned the data in the way described in Communication-Efficient Learning of Deep Networks from Decentralized Data paper \cite{mcmahan2017communication} by Google. However, in our case the distribution of data differs from the distribution analysed in the paper. We have 100 nodes and 10 classes with 6 000 samples each, while the dataset used in Google's paper is MNIST, which means that classes have different numbers of samples. 

To partition the data we had to compute three steps. Firstly, we sorted the data by class. Secondly, we divided the data into 200 shards with 300 samples each. As we previously sorted the data, each shard can only have samples from one class. Finally, we assigned to each node 2 shards that were chosen randomly from the 200 hundred shards. 

As in our case the number of samples per class is divisible by the shard size, each shard can only have examples from one class. Thus, each node can have examples of 1-2 classes. In contrast, in Google's paper shards can consist of examples of two classes, and therefore each node can have examples of 1-4 classes.

In contrast to the D-Cliques paper \cite{bellet2021dcliques} this partitioning scheme may not always admit an optimal solution when creating cliques in which all cliques have a skew of zero. Therefore, this partitioning scheme is suited to study the relationship between the skew of cliques and convergence speed.

\section{Baseline algorithms}
\label{section:baseline-algorithms}
In order to be able to measure the performance of the algorithms that will be proposed, we need to set some baselines to compare with. In this section we will present the optimal solution and random algorithm respectively.
\subsection{Optimal solution}
\label{subsection:optimal-solution}
The optimal solution for constructing cliques is our lower bound baseline. Our algorithms should be as close to it as possible.

To find the optimal we have to go through all the possible combinations and choose the one with the lowest skew. But, how many combinations do we have to compute? The number of ways to divide \(n\) nodes into \(c\) non-empty cliques is given by the Stirling number of second kind \(S(n,c)\), and hence the number of distinct sets of distributed cliques is \(\sum_{c=1}^{n} S(n,c)\)\footnote{Refer to the page 270 of this file: \url{https://www.csie.ntu.edu.tw/~r97002/temp/Concrete\%20Mathematics\%202e.pdf}}. 
For example, if we want to get the optimal solution for a system of 10 nodes, we need to compute \(\sum_{c=1}^{10} S(10,c) = 115,975\) combinations.

After testing all the combinations, we found out that the trivial solution, which is one clique containing all the nodes, is the one with the lowest skew. Having all the nodes in a unique fully-connected clique gave us a skew of 0 because the distribution of this clique is equal to the global distribution. The main problem of this result is that the topology is the same as having a fully-connected graph, and it is the one with the highest communication cost. Therefore, we decided to remove it from the analysis.

Additionally, we decided to add a constraint on the maximum number of nodes in a clique, to limit the communication cost and measure the effect it has on the skew.

\subsection{Random algorithm}
\label{subsection:random-algorithm}
% To plot this graph, one has to run the file ``decentr_distr_random_cliques.py''.
\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{pictures/other/Skew_size_of_clique_tests_10_without_label.pdf}
	\caption{Random algorithm's performance on the system of 100 nodes. Dependency of the average clique skew from the size of the clique. The data shown on the plot was averaged from 10 runs. The transparent lines show the minimum of minimum skews and maximum of maximum skews across the cliques and all the runs, and the bold line shows the average of the average skews.}
	\label{fig:decentr_cliques_skews}
\end{figure}

The random algorithm for constructing cliques is our upper bound baseline, as it is the simplest algorithm for both centralized and decentralized cases. All proposed algorithms should be not worse than random.

The random algorithm has number of nodes in a clique $k$ as a parameter. It creates $\floor*{\frac{n}{k}}$ cliques of the same size $k$ by randomly assigning nodes to them. If the number of nodes in a system is not divisible by $k$, an additional clique with remaining $n \bmod k$ nodes is created.

The results of calculating the average skew within cliques of different sizes created by the random algorithm are shown in the \autoref{fig:decentr_cliques_skews}. The overall tendency is the decline of the average skew with the increase of the size of the cliques, which is expected. However, the decline is slow and unstable. The maximum skew peaks when the remainder of the division of the number of nodes in a system by number of nodes in a clique is small; e.g. there is a peak at 33 number of nodes, as $100 = 33 \cdot 3 + 1$.

\section{Centralized algorithm}
\label{section:centralized-algorithm}
We first present the centralized greedy algorithm, listed in Algorithm~\ref{Algorithm:Generalized-Streaming-D-Clique-Construction}. 
It leverages the definition of \textit{skew}, introduced in Section~\ref{section:problem-statement}, to determine whether adding a node in an existing clique lowers that clique's skew compared to the global distribution $D$. If so, it adds the node to the clique. Otherwise, it creates a new clique with that node as a sole member. 

This algorithm is a generalization of the optimal algorithm presented in the D-Cliques paper~\cite{bellet2021dcliques}, because it accepts a relaxed data partitioning scheme in which nodes may have examples of more than one class. However, by greedily assigning  all nodes to cliques in a single traversal, it is not guaranteed to find the optimal solution.

\begin{algorithm}[h]
    \caption{Greedy with Pre-Computing of Global Distribution}
    \label{Algorithm:Generalized-Streaming-D-Clique-Construction}
    \begin{algorithmic}[1]
         \State \textbf{Require:} 
         \State~~ set of classes globally present $L$,
         \State~~ set of all nodes $N = \{ 1, 2, \dots, n \}$, and associated distributions $D_1, D_2, \dots, D_n$
         \State
          \Function{prob}{C}
            \State $D_C \leftarrow \bigcup\limits_{\substack{i \in C}} D_i$
            \State \Return $P = [~p(y = l~|~(x,y) \in D_C)  = \sum\limits_{\substack{i \in C}} \frac{| \{ (x,y) \in D_i~|~y = l \} |}{| D_C |} ~\forall l \in L~]$
          \EndFunction
          \Function{skew}{$C_1, C_2$}
            \State $P_1 \leftarrow prob(C_1)$
            \State $P_2 \leftarrow prob(C_2)$
            \State \Return $\sum\limits_{\substack{l \in L}} | p_1(y = l~|~(x,y) \in D_1) - p_2(y = l~|~(x,y) \in D_2) |$
          \EndFunction
 
         \State $D \leftarrow  \bigcup\limits_{\substack{i \in N}} D_i$ \Comment{Compute Global Distribution}
         \State $DC \leftarrow \{ \{ \} \}$ \Comment{Initialize one empty clique}
         \For {$i \in N$} 
           \State \Comment{Select clique for which $i$ best lowers skew}
 
           \State $C \leftarrow \textit{argmin}_{C \in DC}~skew(C \cup \{ i \}, N) - skew(C, N)$           \If {$skew(C \cup \{ i \}, N) - skew(C, N) \ge 0$} \Comment{Not improving skew}
             \State $DC \leftarrow DC \cup \{ i \}$ \Comment{Create new clique}
           \Else
              \State $C \leftarrow C \cup \{ i \}$ \Comment{Add to clique that $i$ helps best}
           \EndIf
         \EndFor
          
         \State \Return $DC$
    \end{algorithmic}
 \end{algorithm}

\autoref{fig:skew-size-of-clique-greedy} shows the average, the maximum and the minimum skew we obtained with progressively larger maximum sizes of cliques. From cliques of maximum size of 15 nodes the average skew stabilizes. It means that from this constraint the algorithm constructs the same distributed cliques, so the skew does not changes. In addition, the maximum is much higher than the average skew through all the constraints, this happens because, usually the last node chooses to create its own clique as  most of the cliques are already full and it doesn’t help to better the skew of remaining cliques.

\begin{figure}[h]
    \centering
    \includegraphics[height=0.6\linewidth]{pictures/final_report/skew_size_of_clique_greedy_shards_partition_100_nodes.pdf}
    \caption{Dependency of the average clique skew from the size of the clique for centralized greedy algorithm. The data shown on the plot was averaged from 10 runs. The upper and lower lines represent the maximum of maximum skews and minimum of minimum skews across the cliques and all the runs respectively and the bold line represents the average of average skews.}
    \label{fig:skew-size-of-clique-greedy}
\end{figure}

\section{Decentralized algorithms}
\label{section:decentralized-algorithms}
Previously, we presented centralized greedy algorithm for constructing the cliques. However, in a fully descentralized setting, no nodes know about all the other nodes. We therefore need decentralized algorithms that can still converge in a more general setting. In this section we present the general pipeline for constructing the cliques in a decentralized fashion, followed by our proposed algorithms: 1) cycle handling algorithm and 2) bipartite algorithm.

\subsection{General idea}
The chosen general pipeline of a decentralized algorithm for constructing the cliques is as follows (listed in Algorithm \ref{Algorithm:general_pipeline}):
\begin{itemize}
\item Each node is considered a clique and the leader of its own clique from the beginning.
\item At every iteration some of the cliques merge and form new, bigger cliques. After merging, each newly created clique chooses a leader from the nodes constituting it. This leader has the information about the distribution of data in a clique and manages the communication on behalf of the clique.
\item Number of iterations $K$ should be empirically tested to find a number large enough, such that for larger $K$ the average skew does not significantly improve.
\end{itemize}
In our solution, for choosing the clique to merge with on the second step of the pipeline, each clique uses the same greedy strategy as in the centralized algorithm. However, in contrast to the centralized version, the cliques do not have access to the information about the global distribution of data and all the other existing cliques. For addressing these two problems, two additional ideas were used:
\begin{itemize}
\item Before running a decentralized algorithm for cliques construction, the preparation step for computing the approximation of the global distribution for each node is needed. This task can be solved by using the PushSum algorithm described in \cite{kempe2003gossip}. Analysis and plots for this algorithm are presented in ~\ref{subsection:PushSum}.
\item We assume that at every iteration instead of having the knowledge of all system, each clique knows about a random sample of other cliques, which can be achieved by using the Peer Sampling algorithm described in \cite{jelasity2007gossip}. From this random sample the clique chooses the best one greedily.
\end{itemize}

\begin{algorithm}[h]
   \caption{General pipeline}
   \label{Algorithm:general_pipeline}
   \begin{algorithmic}[1]
   \State \textbf{Require:} 
   \State~~ the basic distributed communication topology of nodes $G$,
   \State~~ number of nodes $R$ in a random sample,
   \State~~ number of iterations $K$.
   \State
   \State Run \hyperref[Algorithm:PushSum]{PushSum} algorithm on topology $G$
   \State Create the new variable $T = G$, where each vertex represents one clique
   \For {$k = 1, \ldots, K $} 
		\State Run Peer Sampling algorithm on topology $T$ to assign $R$ cliques randomly as neighbours $N_i$ to each clique $i$ in the system
    \State choose\_and\_merge\_cliques($N_{i}$)
		% \State Preference graph $P$ = \textit{choose\_preferred\_clique($N_i$)}
         %\State \textit{Leader of each clique $i$ chooses a preferred clique from $N_i$ and they form a preference graph $P$}
         %\State \textit{Leaders resolve conflicts in $P$}
        %  \State \textit{resolve\_conflicts($P$)}
         \State Choose new leaders for newly formed cliques
         \State Update topology $T$ respectively: merge vertices representing merged cliques
   \EndFor
   \end{algorithmic}
\end{algorithm}

If merging with any clique from the random sample only increases the skew, then the clique does not choose anyone. The choices cliques make can be represented as an oriented graph, where each vertex has not more than one outgoing edge. This graph can have cycles, which leads to conflicts in determining which node to merge with. Two solutions were proposed for this problem: cycle handling algorithm and bipartite algorithm. In the pseudocode for the algorithm \ref{Algorithm:general_pipeline}, the function \verb|choose_and_merge_cliques| depends on which of the two strategies is applied.


\subsection{Cycle handling}
In this solution, there are no additional constraints for choosing the preferred clique: the preferred clique is chosen greedily from all of $N_i$ by the leader of each node $i$, similarly to the centralized version. The focus of the algorithm is on resolving the conflicts.

Each component of the graph of preferences can have no more than one cycle, as the number of edges is not more than the number of vertices. So, each component has a structure of either an oriented tree (if the number of edges equals number of nodes minus one) or a cycle, each of the vertices in which being a root of an oriented tree (if the number of edges equals number of nodes). However, the whole graph is not known to any vertex, every vertex knows only its neighbours in this graph. Therefore, there is a need for a protocol that will let each clique determine the clique from its neighbours it can merge with. Let us describe this protocol (the pseudocode is presented as Algorithm \ref{Algorithm:ComR}).

\begin{algorithm}[H]
     \caption{Decentralized Greedy: Cycle Handling Solution}
     \label{Algorithm:ComR}
     \begin{algorithmic}[1]
     \Statex \textbf{Message format}: (from\_node, to\_node, type), where type can be one of ``YES'', ``NO'', ``INFO''.
     \State \textbf{Require:} 
     \State~~ the clique $A$ which runs this code,
     \State~~ random sample $N_i$.
     \State
     \Function{answer\_nodes\_that\_prefer\_me}{F}
              \State Choose randomly a clique $B \in F$ to merge with
              \State Send $B$ a YES-message
              \State Send a NO-message to all other cliques from $F$
              \State \Return
     \EndFunction
     \State
     \Function{choose\_and\_merge\_cliques}{$N_i$}
     \State Select current preferred node $P$ greedily from $N_i$
     \State Initialize graph $G$ with all the information $A$ knows about the preference graph with the edge $(A, P)$
     \State Send an INFO-message to $P$ about myself
     \State Receive INFO-messages $M$ from the set $F$ of nodes that prefer me
     \If {$P$ is $None$} \Comment{There is not any outgoing edge from $A$}
         \State answer\_nodes\_that\_prefer\_me(F)
              \State \Return 
     \EndIf
     \algstore{myalg}
     \end{algorithmic}
\end{algorithm}

\begin{algorithm}[H]
     \begin{algorithmic}
     \algrestore{myalg}
     \State \Comment{There is an outgoing edge from $A$}
     \While {True} \Comment{Repeat iterations until achieving return point}
       \For {$m \in M$} 
           \If {m.type == ``INFO''}
                \State Add edge (m.from\_node, m.to\_node) to $G$
                \If {m.from\_node == P}
                \State \Comment {Node $A$ is in a cycle, all its edges are already in $G$}
                      \State Extract cycle $C$ from $G$
                      \State Choose the clique $S$ with the minimum id in $C$
                      \State Split cliques from $C$ into pairs starting from $S$
                      \If {$len(C)$ is even or $A$ is not the last vertex in $C$}
                            \State Merge $A$ with the clique from its pair
                            \State Send a NO-message to all cliques from $F$
                      \Else \Comment{If $len(C)$ is odd and $A$ is the last vertex in $C$}
                            \State answer\_nodes\_that\_prefer\_me(F)
                      \EndIf
                      \State \Return
                 \EndIf
           \Else \Comment{$A$ received the answer from $P$: either there was}
           \State \Comment{no cycle in the component, or the cycle was broken}
                \If{m.type == ``YES''}
                     \State Merge $A$ and $P$
                     \State Send a NO-message to all cliques from $F$
                \ElsIf{m.type == ``NO''}
                     \State answer\_nodes\_that\_prefer\_me(F)
                \EndIf
                \State \Return
           \EndIf
       \EndFor
       \State Send $M$ to $P$
       \State Receive messages $M$ from this round
     \EndWhile
     \EndFunction
     \end{algorithmic}
\end{algorithm}

\begin{figure}[h]
	\centering
	\begin{subfigure}{0.4\textwidth}
	  \centering
    \includegraphics[height=0.25\textheight]{pictures/final_report/before_rounds_numbers.pdf}
    \caption{Preference graph}
	  \label{fig:cycle_handling_a}
	\end{subfigure}
	\begin{subfigure}{0.4\textwidth}
    \centering
    \includegraphics[height=0.25\textheight]{pictures/final_report/1_round_numbers.pdf}
    \caption{First communication round}
    \label{fig:cycle_handling_b}
	\end{subfigure}
	\begin{subfigure}{0.4\textwidth}
    \centering
    \includegraphics[height=0.25\textheight]{pictures/final_report/2_round_numbers.pdf}
    \caption{Second communication round}
    \label{fig:cycle_handling_c}
	\end{subfigure}
	\begin{subfigure}{0.4\textwidth}
    \centering
    \includegraphics[height=0.25\textheight]{pictures/final_report/final_round_numbers.pdf}
    \caption{Merging cliques}
    \label{fig:cycle_handling_d}
	\end{subfigure}
	\caption{Cycle handling process}
	\label{fig:cycle_handling}
\end{figure}


The protocol consists of communication rounds:
\begin{itemize}
\item At the first communication round each clique sends information about itself to the chosen clique from a random sample (or to no one, if no clique was chosen). This happens in lines 14-15 of \ref{Algorithm:ComR}.
\item All the subsequent rounds are similar to each other. Cliques propagate information by resending messages received on previous communication rounds to their preferred clique.
\begin{itemize}
\item That allows cliques to \textbf{identify a cycle} in their graph component: if they receive a message that was initially sent by their preferred clique, they are in a cycle. 
\item After identifying a cycle, every vertex from it \textbf{chooses deterministically the starting vertex of the cycle} as a clique with minimal id.
\item Subsequently, each clique can \textbf{split a cycle in pairs} of cliques that are going to merge. If length of the cycle is even, then every clique has a pair. Otherwise, the last vertex in the cycle (the one just before the clique with minimal id) does not have a pair, and thus it will merge with one of the nodes that prefer it.
\item Then every vertex from the cycle \textbf{sends its decision to the vertices out of the cycle that prefer it}. If the vertex has a pair in the cycle, it sends rejection, otherwise it sends acceptance to one node and rejection to others (this task is performed by function \verb|answer_nodes_that_prefer_me| in the pseudocode \ref{Algorithm:ComR}).
\item Afterwards, \textbf{the remaining cliques can make a decision on which clique to merge with} based on the answer of their preferred node.
\end{itemize}
The clique runs the communication rounds until it finds out which clique it merges with and sends acceptance/rejection messages to all the nodes that prefer it. In ALgorithm \ref{Algorithm:ComR} the points of ceasing the communication rounds are marked as \textbf{return} statements.
\end{itemize}

\autoref{fig:cycle_handling} shows the process of cycle handling for an example of 4 nodes. On \autoref{fig:cycle_handling_a} the initial preference graph is shown. On \autoref{fig:cycle_handling_b} and \autoref{fig:cycle_handling_c} two communication rounds are shown, with messages received by each node at every round displayed near it. Each message is a tuple that describes an edge and consists of starting and finishing node of an edge. Node D does not receive any message, as it does not have any incoming edge. After the second round each node knows about an edge coming out of its preferred node, e.g. node A knows about an edge (B, C). Then nodes identify a cycle and choose A as a starting point to break it, as A is the first in the alphabetical order. That means that cycle consists of a pair (A, B) and a free node C, which can, in turn, merge with its neighbour D. The final merging decisions are shown on \autoref{fig:cycle_handling_d}.

%If we look at the preference graph more closely, we can distinguish 2 variants of how the component of the graph can look like: either it does not have a cycle, which means that it is an oriented tree, or it does have a cycle, and then each node from the cycle is a root for an oriented tree. In the first case, the conflicts are resolved starting from the clique that does not have a preferred clique, while in the second case the conflicts are resolved starting with breaking the cycle.


\subsection{Bipartite algorithm}
Bipartite algorithm is another solution to decentralize the greedy algorithm, in which the main idea is to remove the possibility of having cycles instead of resolving them.
It is based on the notion of a bipartite graph, in which the nodes are divided into two groups: group A and group B. To do so, each node chooses its group randomly.

The process for constructing the cliques follows the Algorithm \ref{Algorithm:decentralized-bipartite}, which consists of two steps:
\begin{enumerate}
    \item Each node from group A chooses its preferred node from the part of its random sample that belongs to group B. Only nodes from group A participate in this step.
    \item Each node from group B chooses the node that improves the skew the most from the nodes that prefer it. Only nodes from group B participate in this step.
\end{enumerate}

During the steps described above, each node can be performing different activities:
\begin{enumerate}
    \item Node from group A:
    \begin{enumerate}
        \item First step:
        \begin{enumerate}
            \item  If it has nodes from group B in its random sample, it selects a node from group B.
            \item If it does not have any node from group B in its random sample, it waits for the next iteration
        \end{enumerate}
        \item Second step:
        \begin{enumerate}
            \item Waits for an answer of acceptance or rejection to be merged from its preferred node.
        \end{enumerate}
    \end{enumerate}
    \item Node from group B:
    \begin{enumerate}
        \item First step:
        \begin{enumerate}
            \item Waits for preferences from nodes of group A.
        \end{enumerate}
        \item Second step:
        \begin{enumerate}
            \item If it has nodes that prefer it, it merges with the one that improves the skew the best.
            \item If it does not have any node that prefers it, it waits for the next iteration.
        \end{enumerate}
    \end{enumerate}
\end{enumerate}
Refer to \autoref{fig:states-of-nodes-during-bipartite-steps} to see a graphical example of the different states of the nodes.


\begin{figure}[h]
  \centering
  \includegraphics[width=0.5\textwidth]{pictures/final_report/bipartite-nodes-states.pdf}
  \caption{Representation of the different activities that each node may perform, during the first and second step of cliques creation in bipartite algorithm. In this example, each node knows a random sample of three nodes. Dashed nodes represent the random sample of the filled node of the same color and the rectangle represent the process of merging two nodes.
  Purple and yellow nodes from group A notify their preferred node (gray node) from group B (1.1 and 1.2) and wait for a response. Then, the gray node from group B chooses the purple node as the one that improves its skew the best and sends a message of acceptance and rejection to purple and yellow nodes respectively (2.1 and 2.2). Finally, the gray node from group B merges with the purple node and the yellow node waits for the next iteration.}
  \label{fig:states-of-nodes-during-bipartite-steps}
\end{figure}

\begin{algorithm}
    \caption{Decentralized Greedy: Bipartite Solution}
    \label{Algorithm:decentralized-bipartite}
    \begin{algorithmic}[1]
      \Statex \textbf{Message format}: (from\_node, to\_node, type), where type can be one of ``YES'', ``NO''.
      \State \textbf{Require:}
      \State~~ the clique $C$ which runs this code,
      \State~~ random sample $N_{i}$.

      \State
      \Function{choose\_and\_merge\_cliques}{$N_{i}$}
        \State Choose own group randomly from $\{A,B\}$

        \If{group == A}
          \State Choose current preferred clique $P$ from $N_{i}$ $\cap$ group  $B$
          \State Send request to $P$
          \If{answer == YES}
            \State Merge with $P$
          \EndIf
        \EndIf

        \If{group == B}
          \If{C has nodes that prefer it}
            \State Choose clique that improves the skew the most $S$ from set of cliques that prefer C
            \State Send YES to $S$
            \State Send NO to all other cliques that preferred C
          \EndIf
        \EndIf
      \EndFunction
    \end{algorithmic}
 \end{algorithm}


\subsection{PushSum algorithm}
\label{subsection:PushSum}

As a preparation step for running the decentralized algorithms, the PushSum algorithm from~\cite{kempe2003gossip} for computing the estimate of the global distribution for each node is used. The algorithm is restated in ~\ref{Algorithm:PushSum}. The main property of the algorithm is \textit{mass conservation}: the sum of all $S_{t, i}$ in the network at every step $t$ is a total sum of original $S_i$ and the sum of all $w_{t, i}$ is $n$. Eventually, the $\frac{S_{t, i}}{w_{t}}$, which is the estimate of the average at every step, converges to the true average. The estimate of the global distribution of the classes can be found at the end of each step by dividing each entry of the resulting array by the sum of its elements. 

\begin{algorithm}
   \caption{PushSum}
   \label{Algorithm:PushSum}
   \begin{algorithmic}[1]
   \State Let $S_i$ be the array with numbers of samples of each class on the node $i$
   \State All nodes send to themselves a pair $(S_i, 1)$
   \For {$t = 1, \ldots, T $} 
		\State Let $\left\{\left(\hat{S}_{r}, \hat{w}_{r}\right)\right\}$ be all pairs sent to $i$ in round $t-1$
         \State Let $S_{t, i}:=\sum_{r} \hat{S}_{r}, w_{t, i}:=\sum_{r} \hat{w}_{r}$
         \State $\frac{S_{t, i}}{w_{t}}$ is the estimate of the average of the number of samples for each class at step $t$
         \State Compute the next message: the pair $\left(\frac{1}{2} S_{t, i}, \frac{1}{2} w_{t, i}\right)$
         \State Choose a target $f_{t}(i)$ uniformly at random
         \State Send the computed message to $f_{t}(i)$ and $i$ (yourself)
   \EndFor
   \end{algorithmic}
\end{algorithm}
In terms of number of messages the protocol is inexpensive. During each iteration the node sends one message to a randomly chosen neighbour, so the number of messages is linear in the number of nodes.

% To plot this graph, one has to run the file ``decentr_distr.py'' with WHAT_TO_PLOT = ``SKEW'' and 3, then 8 configurations. Refer to \autoref{fig:node-a-selecting-node-b}.
\begin{figure}[h]
\centering
	\begin{subfigure}[t]{0.45\textwidth}
	\centering
        \includegraphics[width=\textwidth]{pictures/final_report/SKEW_N_100_CLASSES_10.pdf}
        \caption{Different topologies}
        \label{fig:decentr_skew_a}
    \end{subfigure}
	\begin{subfigure}[t]{0.45\textwidth}
	\centering
        \includegraphics[width=\textwidth]{pictures/final_report/SKEW_N_100_CLASSES_10_RANDOM_4_RANDOM_True.pdf}
        \caption{Random Graph with different numbers of neighbours}
        \label{fig:decentr_skew_b}
    \end{subfigure}
	\caption{The dependency of the average skew from the number of iterations for four different topologies with the same number of 100 vertices.}
	\label{fig:decentr_skew}
\end{figure}

% To plot this graph, one has to run the file ``decentr_distr.py'' with WHAT_TO_PLOT = ``MIN_MAX_SKEW'' and third, then 12th configuration.
\begin{figure}
\vspace*{-3cm}
	\centering
	\begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=0.7\textwidth]{pictures/final_report/MIN_MAX_SKEW_N_100_CLASSES_10.pdf}
    \caption{Different topologies}
    \label{fig:decentr_min_max_skew_a}
    \end{subfigure}
	\begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=0.7\textwidth]{pictures/final_report/MIN_MAX_SKEW_N_100_CLASSES_10_RANDOM_2.pdf}
    \caption{Random Graph with different numbers of neighbours}
    \label{fig:decentr_min_max_skew_b}
	\end{subfigure}
	\begin{subfigure}{\textwidth}
    \centering
    \includegraphics[width=0.7\textwidth]{pictures/final_report/MIN_MAX_SKEW_N_100_CLASSES_10_RANDOM_2_RANDOM_True.pdf}
    \caption{Random Graph with the constraint on connectivity}
    \label{fig:decentr_min_max_skew_c}
	\end{subfigure}
	\caption{Minimum and maximum skew across all nodes depending on the iteration.}
	\label{fig:decentr_min_max_skew}
\end{figure}

In our study, the PushSum algorithm was tested for four different topologies: Ring, Grid, Fully-Connected and Random Graph with 10 neighbours. \autoref{fig:decentr_skew_a} shows the convergence speeds of the algorithm run on these topologies. It can be seen from the plot that the most efficient topologies are Fully-Connected and Random Graph. The difference between their convergence speeds is insignificant. 
The most ineffective topology turns out to be the ring, that gets to 0.1 average skew only after 40 iterations (in contrast to other topologies that get to 0.1 within the first 10 iterations). 

\autoref{fig:decentr_skew_b} shows the average convergence speeds of the Random Graph topology with different numbers of neighbours. By using different numbers of neighbours, we can simulate situations analogous to different topologies. Random Graph with only 2 neighbours shows a little worse convergence speed than that of the Ring topology. On Random Graph with 3 neighbours the algorithm already converges faster than on the Grid topology. This happens because choosing the neighbours randomly can lead to lower length of the average path between the nodes. However, random choice does not give any guarantees on the connectivity of the resulting graph. Therefore, in contrast to the Ring topology, Random Graph with 2 neighbours can become disconnected. Random Graph with 99 neighbours for a network of 100 nodes gives the Fully-Connected topology, so the convergence speed is similar (minor difference stems from the random choice of the neighbouring node on every communication round).

% points for every iteration
% To plot this graph, one has to run the file ``decentr_distr_to_all_neigh.py'' with second configuration.
\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{pictures/final_report/TWO_SKEWS_N_100_CLASSES_10.pdf}
	\caption{Dependency of the skew from the number of sent messages for 4 different topologies and 2 different algorithms. The last number in the legend is the number of iterations for each of the algorithms.}
	\label{fig:decentr_2_skews}
\end{figure}

The variance of skew across the nodes is shown on \autoref{fig:decentr_min_max_skew_a}. The ring topology has the largest deviation, with maximum skew not reaching 0.1 even within the first 100 iterations. \autoref{fig:decentr_min_max_skew_b} shows the deviation of the skew for the Random Graph with 2 and 3 neighbours for comparison with the Ring and Grid topology. It can be seen from the plot that after a number of iterations the maximum skew of the Random Graph with 2 neighbours does not change. This happens, because the graph is disconnected, and one of the small components needs less than 20 iterations to average all its distributions. On the other hand, the Random Graph with 3 neighbours has smaller deviation than the graph with the Grid topology. \autoref{fig:decentr_min_max_skew_c} shows the minimum and maximum skew for connected Random Graphs with 2 and 3 neighbours. It can be noted from the plot that the deviation of skew for a Random Graph with 2 neighbours is less than for a Ring topology.

As a point of comparison, a modification of PushSum algorithm in which the node sends the message to all its neighbours (instead of just one) was implemented. Then the plots, in \autoref{fig:decentr_2_skews}, with dependency of average skew from the number of sent messages were plotted for this and the vanilla PushSum algorithm for each of four topologies. As nodes in the ring and grid have few neighbours (from two to four), the plots for two different algorithms are similar, though the original algorithm still converges faster. For Fully-Connected (FC) topology the second algorithm converges in one iteration, but this iteration requires 10000 messages in contrast to less than 2500 messages of original algorithm. For random graph the difference is not that drastic, but the second algorithm still requires 4 times more messages to converge. To conclude, the original algorithm shows better results in terms of number of messages needed for convergence.

% To plot this graph, one has to run the file ``decentr_distr.py'' with WHAT_TO_PLOT = ``DIRECTED_DIFFERENCE'' and 7th configuration.
\begin{figure}[h]
	\centering
	\includegraphics[width=0.7\textwidth]{pictures/final_report/DIRECTED_DIFFERENCE_N_100_CLASSES_10_RANDOM_100_RANDOM_DIRECTED.pdf}
	\caption{The average skews after 100 iterations for directed and undirected Random Graph for different numbers of neighbours.}
	\label{fig:directed_difference}
\end{figure}

\autoref{fig:directed_difference} shows the difference between the average skews received from running the PushSum algorithm on the undirected and directed Random Graph topology. For each number of neighbours the algorithm was run on 5 different directed and 5 different undirected topologies. Afterwards the obtained average skews were averaged again and plotted. It can be seen from the plot that for the numbers of neighbours less than 6 the average skew from the directed graph is always a little larger than from the undirected. With more than 6 neighbours the results are the same for both variants.


\section{Comparative Evaluation}
\label{section:comparative-evaluation}
\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{pictures/final_report/centr_vs_greedy_bipartite_vs_MV_different_clique_sizes_30_iters_25_seed_sharded.pdf}
	\caption{Comparison of bipartite and cycle handling algorithms' convergence speeds. Each plot represents a constraint on the maximum number of nodes in the clique. The red line on all the plots is the cycle handling algorithm, and the blue line is the bipartite graph algorithm. For each plot and each algorithm 10 experiments with 100 nodes were run. The dashed lines show the maximum of the maximum skews and minimum of the minimum skews across all the runs and all the cliques in a system. The bold lines show the average of the average skews across all runs.}
	\label{fig:comparison_two}
\end{figure}
\autoref{fig:comparison_two} compares the convergence speeds of bipartite and cycle handling algorithms in terms of average skew of constructed cliques. It can be seen from the graphs, that the bipartite algorithm needs more iterations to converge, while in reality the cycle handling algorithm needs more time to finish one iteration. To achieve the same average skew, bipartite algorithm takes around 1.5-2 times more iterations. At the end the curve of the bipartite algorithm stabilizes at the higher level than that of the cycle handling algorithm, which means that in terms of skew the bipartite algorithm gives worse results.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{pictures/final_report/centr_vs_MV_30_vs_random_vs_bipartite_30_from_max_node_in_a_clique_n_nodes_100_with_std_70_sharded_True.pdf}
	\caption{Comparison of performance of random, centralized and both decentralized algorithms on the system of 100 nodes. The bold lines is average for all 10 conducted experiments, standard deviation is also shown. Both decentralized algorithms were run for 30 iterations.}
	\label{fig:comparison_four_100}
\end{figure}

\autoref{fig:comparison_four_100} compares the average skew of the final systems constructed by all the above-mentioned algorithms, except for the optimal one. We decided not to use this baseline, as running it takes a lot of time and memory for larger number of nodes. It can be seen from the plot that in the beginning centralized algorithm is the best one, but after having maximum of 15 nodes in a clique, it stabilizes, and then it becomes the worst algorithm after having roughly 35 nodes in a clique. The bipartite algorithm is very close to random algorithm, but without that much fluctuation. Cycle handling solution beats centralized after having 20 nodes in a clique and almost everywhere it is better than random.

\begin{figure}[h]
	\centering
	\includegraphics[width=0.8\textwidth]{pictures/final_report/centr_vs_MV_30_vs_random_vs_bipartite_30_from_max_node_in_a_clique_n_nodes_600_with_std_420_sharded_True.pdf}
	\caption{Comparison of performance of random, centralized and both decentralized algorithms on the system of 600 nodes. The bold lines is average for all 10 conducted experiments, standard deviation is also shown. Both decentralized algorithms were run for 30 iterations.}
	\label{fig:comparison_four_600}
\end{figure}

The same comparison was also plotted for a system of 600 nodes, scaling the x-axis in the same proportion. The results, as seen on the \autoref{fig:comparison_four_100} are similar: centralized version quickly becomes the worst, bipartite is very similar to random, and cycle handling becomes the best after it beats centralized version, and it is again almost always better than random. We arrive to a conclusion that the cycle handling algorithm performs the best.


\section{Conclusion}
\label{section:conclusion}
In the D-Cliques paper \cite{bellet2021dcliques} an optimal algorithm for constructing cliques was proposed. However, it was based on unrealistic Non-IID assumptions. In this report we relaxed those assumptions by 1) using a different data partition and 2) implementing a generalization of the optimal algorithm presented in the paper. Furthermore, we implemented the optimal solution and random algorithm as our baselines, and proposed two decentralized greedy algorithms: cycle handling and bipartite.

In Section~\ref{section:comparative-evaluation} we compared all algorithms, and concluded that 1) centralized greedy algorithm is the best one with lower clique sizes and 2) cycle handling algorithm is the best algorithm when the maximum size of cliques is greater than 20.

\section{Future work}
\label{section:future-work}
We successfully implemented the centralized greedy algorithm from Section~\ref{section:centralized-algorithm}. Nonetheless, there is a problem related to the distributed cliques this algorithm generates; usually, one of the cliques ends up with a small number of nodes compared to the maximum sizes of cliques. This happens when the last nodes the algorithm traverses choose to create a new clique as most of the cliques are already full and they do not help to better the skew of the remaining ones. Therefore, the centralized greedy algorithm should be modified to mitigate this problem.

Additionally, it is needed to measure the effect that the average skew of the system of D-cliques has on the training process of the model, to understand if the difference in skew between all the algorithms is significant for training machine learning models.



\bibliographystyle{acm}
\bibliography{main}

\appendix

\section{Greedy swap algorithm}
\label{section:greedy-swap-algorithm}
This appendix is an extension of the work we did in our internship, which is detailed in previous sections. The appendix shows a preliminary analysis of 1) greedy swap algorithm and 2) model accuracy results.

In Section~\ref{section:comparative-evaluation} we compared all the proposed algorithms to find the one that works better to minimize the average skew between the distribution of the data of the constructed cliques and the global distribution. In that comparison, the random algorithm was our baseline and cycle handling was the only algorithm that beat random. 

Despite the cycle handling algorithm is better than random in terms of skew, the difference is not significant and takes much more time to compute than random. Therefore, we tested greedy swap, a new and simpler algorithm which was proposed to us.

Greedy swap algorithm works over random algorithm. It receives the cliques constructed by random and performs a fixed number of iterations that depend on the data distribution. For each iteration the algorithm:
\begin{enumerate}
  \item Takes a random sample of two cliques.
  \item Computes the skew between these two cliques and stores it as a baseline.
  \item Takes one node from each selected clique and swap them to calculate the skew from these updated cliques. Then, calculates the difference this skew and the baseline from Step 1. If the difference is lower than cero the value is stores in a list. A difference lower than zero means that the skew has improved by swapping the nodes. The algorithm perform this step for every possible pair of nodes from the two random cliques.
  \item If there is at least one pair of nodes that after swapping them the skew between cliques is improved, the algorithm selects one pair of nodes from the list by random and swap them.
\end{enumerate}

The results of calculating the average skew within cliques of different sizes created by the greedy swap algorithm are shown in the \autoref{fig:skew-size-greedy-swap}. The algorithm was run with 100 nodes, and the overall tendency is the decline of the average skew with the increase of the size of the cliques, which is expected. From a clique size of 10, the average skew is 0, except for the clique size of 20 where the average skew is not 0 but really close to it.

\begin{figure}[h]
	\centering
	  \includegraphics[width=0.8\textwidth]{pictures/final_report/skew_size_of_cliques_greedy_swap_shards_partition_100_nodes.pdf}
    \caption{Dependency of the average clique skew from the size of the clique for greedy swap algorithm. The upper and lower lines represent the maximum of maximum skews and minimum of minimum skews across the cliques and all the runs respectively and the bold line represents the average of average skews.}
    \label{fig:skew-size-greedy-swap}
\end{figure}

Convergence speed of average skew of six different constraints was also plotted in \autoref{fig:convergence-speed-greedy-swap}. For each plot and each algorithm 200 iterations with 100 nodes were run. The plots show that the higher the clique sizes are, the smaller the number of iterations the algorithm needs to converge and the smaller the variance is. The figures also show that the average skew from clique sizes of 30 converges to 0. But, it depends on the distribution of the data, there are some cases when the average skew cannot be 0.

\begin{figure}[h]
	\centering
    \includegraphics[width=\textwidth]{pictures/final_report/convergence_speed_greedy_swap_shards_partition_100_nodes.pdf}
    \caption{Greedy swap algorithm's convergence speed.  Each plot represents a constraint on the maximum number of nodes in the clique. For each plot and each algorithm 200 iterations with 100 nodes were run.  The upper and lower lines show the maximum of the maximum skews and minimum of the minimum skews across all the runs and all the cliques in a system.  The bold lines show the average of the average skews across all runs.}
    \label{fig:convergence-speed-greedy-swap}
\end{figure}


\section{Model accuracy}
\label{section:model-accuracy}
In Section~\ref{section:future-work} we mentioned the need to measure the effect that the average skew of the system of D-cliques has on the training process of the model, to understand if the difference in skew between all the algorithms is significant for training machine learning models.

In this Section of the appendix, we did a preliminary exploration of the convergence speed of all proposed algorithms in \autoref{fig:convergence-speed-greedy-swap} with a maximum number of 5, 10, and 20 nodes respectively. In all plots greedy swap algorithm performs the best and has a low variance, followed closely by the cycle handling algorithm. The random algorithm is the one with higher variance, especially in \autoref{fig:gs-random-ch-bipartite-10} and all other algorithms are better than random.

In Section~\ref{section:greedy-swap-algorithm} we noticed that the average skew in the greedy swap algorithm can converge closely to 0, being the best of all algorithms in terms of skew. Therefore, the relation between the average skew and the convergence speed of the model can be studied to find if there exists a correlation between them.

\begin{figure}[ht]
	\centering
    \begin{subfigure}{\textwidth}
      \centering
      \includegraphics[height=4.5cm]{pictures/final_report/gs-random-ch-bipartite-5.pdf}
      \caption{All algorithms with a constraint of maximum 5 nodes per clique}
      \label{fig:gs-random-ch-bipartite-5}
    \end{subfigure}
    \begin{subfigure}{\textwidth}
      \centering
      \includegraphics[height=4.5cm]{pictures/final_report/gs-random-ch-bipartite-10.pdf}
      \caption{All algorithms with a constraint of maximum 10 nodes per clique}
      \label{fig:gs-random-ch-bipartite-10}
    \end{subfigure}
    \begin{subfigure}{\textwidth}
      \centering
      \includegraphics[height=4.5cm]{pictures/final_report/gs-random-ch-bipartite-20.pdf}
      \caption{All algorithms with a constraint of maximum 20 nodes per clique}
      \label{fig:gs-random-ch-bipartite-20}
    \end{subfigure}
	\caption{Convergence speed of every algorithm with constraints of maximum 5, 10, and 20 nodes per clique respectively. The plots show the dependency of the validation accuracy from the epochs. Each algorithm is represented by a color and 3 lines, the upper and lower lines represent the maximum and minimum and the bold line represent the average of the validation accuracy.}
	\label{fig:gs-random-ch-bipartite}
\end{figure}
\end{document}  